//
//  Disassembler of lengths
//  (c)SEN, Kemerovo, 2009,2010,2016
//
//  Free for non-commercial use
//
//  1.20 - add SSE 4.2 opcodes
//  1.21 - know RDRAND, RDSEED
//

#pragma once

#if __cplusplus
 extern "C"
 {
#endif

#if defined DILA_EXPORTS
#define _DILAEXPORT  __declspec(dllexport)
#else
#define _DILAEXPORT
#endif

typedef struct{
  union{   unsigned int x;
   struct{ unsigned int fullLength      :5,
                        prefixesLength  :4,
                        opcodeLength    :2,
                        modrmLength     :3,
                        immLength       :4,
                        bInvalidOpcode  :1,
                        bPrefix66       :1,
                        bPrefix67       :1,
                        bRex            :1,
                        bX87            :1,
                        bSSE            :1,
                        bVMX            :1;
          };
       };   
  }DILAPACK;

enum{ dila_no_x87               = 0x001,
      dila_no_sse               = 0x002,
      dila_no_vmx               = 0x004,
      dila_parse_invalid_opcode = 0x100,
  };

_DILAEXPORT DILAPACK  Dila( unsigned char *pStream, int codesize /*16|32|64*/, int dilaflags );

#if __cplusplus
 };
#endif

////////////////////////////////////////////////////////////
